KeyUsage (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.asn1.x509

## Class KeyUsage

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.x509.KeyUsage

- All Implemented Interfaces:
    ASN1Encodable, Encodable

      public class KeyUsage
      extends ASN1Object

  The KeyUsage object.

          id-ce-keyUsage OBJECT IDENTIFIER ::=  { id-ce 15 }

          KeyUsage ::= BIT STRING {
               digitalSignature        (0),
               nonRepudiation          (1),
               keyEncipherment         (2),
               dataEncipherment        (3),
               keyAgreement            (4),
               keyCertSign             (5),
               cRLSign                 (6),
               encipherOnly            (7),
               decipherOnly            (8) }

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `cRLSign`
    `static int` | `dataEncipherment`
    `static int` | `decipherOnly`
    `static int` | `digitalSignature`
    `static int` | `encipherOnly`
    `static int` | `keyAgreement`
    `static int` | `keyCertSign`
    `static int` | `keyEncipherment`
    `static int` | `nonRepudiation`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `KeyUsage(int usage)` Basic constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static KeyUsage` | `fromExtensions(Extensions extensions)`
    `byte[]` | `getBytes()`
    `static KeyUsage` | `getInstance(java.lang.Object obj)`
    `int` | `getPadBits()`
    `boolean` | `hasUsages(int usages)` Return true if a given usage bit is set, false otherwise.
    `ASN1Primitive` | `toASN1Primitive()` Method providing a primitive representation of this object suitable for encoding.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `encodeTo, encodeTo, equals, getEncoded, getEncoded, hasEncodedTagValue, hashCode`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### digitalSignature

          public static final int digitalSignature

      See Also:
        Constant Field Values

    - #### nonRepudiation

          public static final int nonRepudiation

      See Also:
        Constant Field Values

    - #### keyEncipherment

          public static final int keyEncipherment

      See Also:
        Constant Field Values

    - #### dataEncipherment

          public static final int dataEncipherment

      See Also:
        Constant Field Values

    - #### keyAgreement

          public static final int keyAgreement

      See Also:
        Constant Field Values

    - #### keyCertSign

          public static final int keyCertSign

      See Also:
        Constant Field Values

    - #### cRLSign

          public static final int cRLSign

      See Also:
        Constant Field Values

    - #### encipherOnly

          public static final int encipherOnly

      See Also:
        Constant Field Values

    - #### decipherOnly

          public static final int decipherOnly

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### KeyUsage

          public KeyUsage(int usage)

      Basic constructor.
      Parameters:
        `usage` - - the bitwise OR of the Key Usage flags giving the allowed uses for the key. e.g. (KeyUsage.keyEncipherment | KeyUsage.dataEncipherment)

  - ### Method Detail

    - #### getInstance

          public static KeyUsage getInstance(java.lang.Object obj)

    - #### fromExtensions

          public static KeyUsage fromExtensions(Extensions extensions)

    - #### hasUsages

          public boolean hasUsages(int usages)

      Return true if a given usage bit is set, false otherwise.
      Parameters:
        `usages` - combination of usage flags.
      Returns:
        true if all bits are set, false otherwise.

    - #### getBytes

          public byte[] getBytes()

    - #### getPadBits

          public int getPadBits()

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### toASN1Primitive

          public ASN1Primitive toASN1Primitive()

      Description copied from class: `ASN1Object`
      Method providing a primitive representation of this object suitable for encoding.
      Specified by:
        `toASN1Primitive` in interface `ASN1Encodable`
      Specified by:
        `toASN1Primitive` in class `ASN1Object`
      Returns:
        a primitive representation of this object.